#include <stdio.h>
#include <math.h>
#include <time.h>
// 点
// point
struct point{ double x;double y;};
// 結果を保持する点列
// The points which preserves the results
struct point result_points[1000001];
// 多角形
// polygons
struct polygon_type{
	// 多角形の点
	struct point points[10001];
	// 多角形の辺の数
	int point_number;
	// 多角形の辺の長さの最大値
	double max_distance;
};
struct polygon_type polygon;
struct point minpoint;
// 直線を定義する構造体
struct line{
	// ax + by + c
	int a,b,c;
	// 直線が通る２点（交点を求めるのに使用）
	// the two points that the line passes(It is used when it determines the cross points)
	double x1,x2,y1,y2;
	// the normal vector to the line
	// 法線ベクトル
	double na,nb;
};
struct line lines[10001];
// 二乗を計算する関数
// the function to calculate the square
double pow2(double val){
	return val * val;
}
// 内積を計算する関数
// the function to calculate the inner product 
double inner_product(double x,double y,double a,double b){
	return x * a + y * b;
}
// ポリゴンを作成する関数
// the function to make polygons
void MakePolygon(){
	int i;
	double dist;
	polygon.max_distance = 0;
	polygon.points[0].x= 10000*cos((double)0 /10000 * M_PI * 2); 
	polygon.points[0].y = 10000*sin((double)0 /10000 * M_PI * 2); 
	for(i = 1;i<=10000;i++){
		polygon.points[i].x = 10000*cos((double)i /10000 * M_PI * 2); 
		polygon.points[i].y = 10000*sin((double)i /10000 * M_PI *2); 
		dist = sqrt(pow2(polygon.points[i].x-polygon.points[i-1].x)+pow2(polygon.points[i].y-polygon.points[i-1].y));
		// 多角形の最大辺を求める
		polygon.max_distance = polygon.max_distance > dist ? polygon.max_distance : dist;
		
	}
	polygon.point_number=10000;
}
// 直線を作成
// making lines
void MakeLines(){
	int i;
	double length;
	for(i = 0; i< 10001;i++){
		lines[i].a = rand()%10000 - 5000;	
		lines[i].b = rand()%10000 - 5000;	
		lines[i].c = rand()%10000 -5000;	
		// a と b が０の場合は直線でないのでcontinue
		// when a and b are 0 it's not a line so continue
		if(lines[i].a == 0 && lines[i].b == 0){
			i--;
			continue;
		}
		// 直線が通る２点を計算
		// the two points that the line passes
		if(lines[i].b !=0){
			lines[i].y1 = -((double)(lines[i].c)) /((double)(lines[i].b)); 	
			lines[i].x1 = 0;
		}else{
			lines[i].y1 = 1; 	
			lines[i].x1 = -((double)(lines[i].c)) /((double)(lines[i].a)); 	

		}
		if(lines[i].a !=0){
			lines[i].x2 = -((double)(lines[i].c)) /((double)(lines[i].a)); 	
			lines[i].y2 = 0;
		}else{
			lines[i].x2 = 1; 	
			lines[i].y2 = -((double)(lines[i].c)) /((double)(lines[i].b)); 	
		}
		// 法線ベクトルを計算
		// calculate the normal vector
		length = sqrt(pow2(lines[i].a)+pow2(lines[i].b));
		lines[i].na = lines[i].a / length;
		lines[i].nb = lines[i].b / length;
	}
}
void KangarooMethod(){
	int i,j,k;
	// スキップする数
	// the number to skip
	int jump;
	double tmpx,tmpy,dist;
	double ksi,eta,delta,lambda,mu;
	// 交点
	struct point CrossP;
	FILE *fp;
	fp = fopen("tmp3","w");
	for(i = 0 ;i<=10000;i++){
		for(j =0;j<polygon.point_number-1;){
			// 交わっている時
			// when the edge crosses the line
			if((lines[i].a * polygon.points[j].x + 
			   lines[i].b * polygon.points[j].y + 
			   lines[i].c ) *
			(lines[i].a * polygon.points[j+1].x + 
			   lines[i].b * polygon.points[j+1].y + 
			   lines[i].c ) < 0 ){
			// 交点を計算
			// calculating the cross points
			ksi = ( polygon.points[j+1].y-polygon.points[j].y )*( polygon.points[j+1].x-lines[i].x1 ) - 
		( polygon.points[j+1].x-polygon.points[j].x )*( polygon.points[j+1].y-lines[i].y1 );
			eta = ( lines[i].x2-lines[i].x1 )*( polygon.points[j+1].y-lines[i].y1 ) -
		( lines[i].y2-lines[i].y1)*( polygon.points[j+1].x-lines[i].x1 );
			delta = ( lines[i].x2-lines[i].x1 )*( polygon.points[j+1].y-polygon.points[j].y ) -
				( lines[i].y2-lines[i].y1)*( polygon.points[j+1].x-polygon.points[j].x );
			lambda = ksi/delta;	
			mu = eta / delta;
			CrossP.x = lines[i].x1 + lambda*(lines[i].x2- lines[i].x1);	
			CrossP.y = lines[i].y1 + lambda*(lines[i].y2- lines[i].y1);	
			fprintf(fp,"line %d %d %d\n",lines[i].a,lines[i].b,lines[i].c);
			fprintf(fp,"segment %f %f %f %f\n",polygon.points[j].x,polygon.points[j].y,polygon.points[j+1].x,polygon.points[j+1].y);
			fprintf(fp,"Cross points %f %f\n",CrossP.x,CrossP.y);
			}
			tmpx =  polygon.points[j+1].x - lines[i].x1;
			tmpy =  polygon.points[j+1].y - lines[i].y1;

			dist = fabs(inner_product(lines[i].na,lines[i].nb,tmpx,tmpy));
			jump = dist/polygon.max_distance+1 ;
			j+=jump;
			
			k++;
		} 
	}	
}
// the method to determine the cross points without kangaroo method
// カンガルー法を使わないで交点を計算する関数
void SimpleMethod(){
	int i,j,k=0;
	long a,b,c,d;
	double ksi,eta,delta,lambda,mu;
	struct point CrossP;
	FILE *fp;
	fp = fopen("tmp2","w");
	for(i = 0 ;i<=10000;i++){
		for(j =0;j<polygon.point_number-1;j++){
			// 交わっている時
			// when the line crosses the points
			if((lines[i].a * polygon.points[j].x + 
			   lines[i].b * polygon.points[j].y + 
			   lines[i].c ) *
			(lines[i].a * polygon.points[j+1].x + 
			   lines[i].b * polygon.points[j+1].y + 
			   lines[i].c ) < 0 ){
			// 交点を計算
			// determine the cross points
			ksi = ( polygon.points[j+1].y-polygon.points[j].y )*( polygon.points[j+1].x-lines[i].x1 ) - 
		( polygon.points[j+1].x-polygon.points[j].x )*( polygon.points[j+1].y-lines[i].y1 );
			eta = ( lines[i].x2-lines[i].x1 )*( polygon.points[j+1].y-lines[i].y1 ) -
		( lines[i].y2-lines[i].y1)*( polygon.points[j+1].x-lines[i].x1 );
			delta = ( lines[i].x2-lines[i].x1 )*( polygon.points[j+1].y-polygon.points[j].y ) -
				( lines[i].y2-lines[i].y1)*( polygon.points[j+1].x-polygon.points[j].x );
			lambda = ksi/delta;	
			mu = eta / delta;
			CrossP.x = lines[i].x1 + lambda*(lines[i].x2- lines[i].x1);	
			CrossP.y = lines[i].y1 + lambda*(lines[i].y2- lines[i].y1);	
			fprintf(fp,"line %d %d %d\n",lines[i].a,lines[i].b,lines[i].c);
			fprintf(fp,"segment %f %f %f %f\n",polygon.points[j].x,polygon.points[j].y,polygon.points[j+1].x,polygon.points[j+1].y);
			fprintf(fp,"Cross points %f %f\n",CrossP.x,CrossP.y);
			
			}
			k++;
		} 
	}	
}
int main(){
	int t1,t2;
	
	MakePolygon();
	MakeLines();
	// 時間計測
	// calculate the time it takes to determine the cross points
	t1 = clock();
	SimpleMethod();
	t2 = clock();
	printf("time1 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
	t1 = clock();
	KangarooMethod();
	t2 = clock();
	printf("time2 = %f[s]\n", (double)(t2-t1)/CLOCKS_PER_SEC);
}


